<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Service\SmPercentualDescontoOperadorService;

class SmPercentualDescontoOperadorController extends SMCrud
{
    
    protected $dataSourceName = 'fct_percdescoper_widget';
    protected $ServicePercDescOper;
    
    
    public function __construct ($crudService, $environment, SmPercentualDescontoOperadorService $ServicePercDescOper)
    {
        parent::__construct($crudService, $environment);
        $this->ServicePercDescOper = $ServicePercDescOper;
    }
    
    public function save(Request $request, Response $response) {
        $request->setParameter('dbname', 'fct_percdescoper_widget');
        parent::save($request, $response);
	    $response->addDataSet(new DataSet('columnsToReturn', $this->crudService->getColumnsToReturn()));
    }
    
    /**
     * A função "validaPercentDescontoOPer" verifica se já existe 
     * um percentual de desconto cadastrado para o operador indicado.
     */
    
    public function validaPercentDescontoOper(Request\Row $request, Response $response) {
    
        $row = $request->getRow();
        
        $parcOperador = $row['NRPARCNEGOCIO']; 
        
        $validaPercDescOper = $this->ServicePercDescOper->validaPercentDescontoOper($parcOperador);
        
        $dtsValPercDescOper = new DataSet('VALIDAOPER', array('VALIDA'=>$validaPercDescOper));
        
        $response->addDataSet($dtsValPercDescOper);
    
    }
    
    public function find(Request\Filter $request, Response $response) {
    
        $request->setParameter('dbname', 'fct_percdescoper_widget');
        parent::find($request, $response);
    
    }
    
    public function delete(Request $request, Response $response) {
    
        $request->setParameter('dbname', 'fct_percdescoper_widget');
        parent::delete($request, $response);
    
    }
}
?>